diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodesValues.java b/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodesValues.java
index 558498999..41ca5a927 100644
--- a/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodesValues.java
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodesValues.java
@@ -1,18 +1,85 @@
 package net.minecraft.core.world.settings;
 
+import com.mojang.logging.LogUtils;
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.Tag;
 import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.save.WorldConfigurationReader;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.slf4j.Logger;
 
 import java.util.Map;
+import java.util.Objects;
+import java.util.function.Consumer;
+import java.util.zip.DataFormatException;
 
 public class SettingNodesValues {
+    private static final @NotNull Logger LOGGER = LogUtils.getLogger();
+
+    @SuppressWarnings("unchecked")
+    public static @NotNull CompoundTag serialize(final @NotNull SettingNodesValues values, final @NotNull CompoundTag out) {
+        values.keyedNodeValues.forEach((key, value) -> {
+            final @NotNull ValueSettingNode<Object> nodeAsObject = (ValueSettingNode<Object>) key;
+            out.put(key.getKey(), nodeAsObject.serializeValue(value));
+        });
+
+        return out;
+    }
+
+    @SuppressWarnings("unchecked")
+    public static @NotNull SettingNodesValues deserialize(final @NotNull SettingNode rootNode, final @NotNull Dimension dimension, final @NotNull CompoundTag in) {
+        final @NotNull SettingNodesValues settingNodesValues = new SettingNodesValues(rootNode, dimension);
+
+        for (final @NotNull Tag<?> tag : in.getValues()) {
+            final @NotNull String tagName = tag.getTagName();
+            final @Nullable SettingNode node = rootNode.getChildByKey(tagName);
+
+            if (node instanceof final @NotNull ValueSettingNode<?> objectValueNode) {
+                try {
+                    final @Nullable Object value = objectValueNode.deserializeValue(tag);
+                    settingNodesValues.setNodeValue((ValueSettingNode<Object>) objectValueNode, value);
+                } catch (final @NotNull DataFormatException e) {
+                    LOGGER.warn("Threw exception while deserializing setting node", e);
+                }
+            }
+        }
+
+        return settingNodesValues;
+    }
+
     private final @NotNull SettingNode rootNode;
+    private final @NotNull Dimension dimension;
     private final @NotNull Map<@NotNull ValueSettingNode<?>, @NotNull Object> keyedNodeValues = new Object2ObjectOpenHashMap<>();
     private final @NotNull Map<@NotNull String, @NotNull ValueSettingNode<?>> nodesByKey = new Object2ObjectOpenHashMap<>();
 
-    public SettingNodesValues(final @NotNull SettingNode rootNode) {
+    private boolean notificationsSuppressed = false;
+    private @Nullable WorldConfiguration.ChangeListener changeListener;
+
+    public SettingNodesValues(final @NotNull SettingNode rootNode, final @NotNull Dimension dimension) {
         this.rootNode = rootNode;
+        this.dimension = dimension;
+    }
+
+    public void setChangeListener(final @Nullable WorldConfiguration.ChangeListener changeListener) {
+        this.changeListener = changeListener;
+    }
+
+    private void notifyChanged() {
+        if (this.changeListener != null && !this.notificationsSuppressed) {
+            this.changeListener.onChanged();
+        }
+    }
+
+    public void setAll(final @NotNull SettingNodesValues src) {
+        this.keyedNodeValues.clear();
+        this.nodesByKey.clear();
+
+        for (final @NotNull ValueSettingNode<?> node : src.keyedNodeValues.keySet()) {
+            this.keyedNodeValues.put(node, Objects.requireNonNull(src.keyedNodeValues.get(node)));
+            this.nodesByKey.put(node.getKey(), node);
+        }
     }
 
     public @NotNull SettingNode getRootNode() {
@@ -20,24 +87,45 @@ public class SettingNodesValues {
     }
 
     @SuppressWarnings("unchecked")
-    public <T> @NotNull T getNodeValue(final @NotNull ValueSettingNode<T> node) {
-        final @Nullable T value = (T) this.keyedNodeValues.get(node);
-        if (value != null) {
-            return value;
+    public <T> @NotNull T getNodeValue(final @NotNull ValueSettingNode<T> node, final @NotNull WorldConfigurationReader worldConfigurationReader) {
+        if (!this.keyedNodeValues.containsKey(node)) {
+            this.keyedNodeValues.put(node, node.getDefaultValue(this.dimension, worldConfigurationReader));
         }
+        return (T) Objects.requireNonNull(this.keyedNodeValues.get(node));
+    }
 
-        final @NotNull T defaultValue = node.getDefaultValue();
-        this.keyedNodeValues.put(node, node.getDefaultValue());
-        this.nodesByKey.put(node.getKey(), node);
+    @SuppressWarnings("unchecked")
+    public <T> @NotNull T getNodeValueOr(final @NotNull ValueSettingNode<T> node, final @NotNull T or) {
+        if (!this.keyedNodeValues.containsKey(node)) {
+            return or;
+        }
+        return (T) Objects.requireNonNull(this.keyedNodeValues.get(node));
+    }
+
+    @SuppressWarnings("unchecked")
+    public <T> @NotNull T getNodeValue(final @NotNull String key, final @NotNull Class<T> valueClass, final @NotNull WorldConfigurationReader worldConfigurationReader) {
+        @Nullable ValueSettingNode<?> node = this.nodesByKey.get(key);
+        if (node == null) {
+            final @Nullable KeyedSettingNode keyedSettingNode = this.rootNode.getChildByKey(key);
+            if (keyedSettingNode instanceof final @NotNull ValueSettingNode<?> nodeByKeyFromRoot) {
+                node = nodeByKeyFromRoot;
+            } else {
+                throw new IllegalArgumentException("Node does not have a value!");
+            }
+        }
 
-        return defaultValue;
+        if (!(valueClass.isAssignableFrom(node.getValueClass()))) {
+            throw new IllegalArgumentException("Node type " + node.getValueClass().getSimpleName() + " does not equal requested type " + valueClass.getSimpleName() + "!");
+        }
+
+        return (T) this.getNodeValue(node, worldConfigurationReader);
     }
 
     @SuppressWarnings("unchecked")
-    public <T> @NotNull T getNodeValue(final @NotNull String key, final @NotNull Class<T> valueClass, final @NotNull WorldConfiguration worldConfiguration) {
+    public <T> @NotNull T getNodeValueOr(final @NotNull String key, final @NotNull Class<T> valueClass, final @NotNull T or) {
         @Nullable ValueSettingNode<?> node = this.nodesByKey.get(key);
         if (node == null) {
-            final @Nullable KeyedSettingNode keyedSettingNode = this.rootNode.getChildByKey(key, worldConfiguration);
+            final @Nullable KeyedSettingNode keyedSettingNode = this.rootNode.getChildByKey(key);
             if (keyedSettingNode instanceof final @NotNull ValueSettingNode<?> nodeByKeyFromRoot) {
                 node = nodeByKeyFromRoot;
             } else {
@@ -49,19 +137,20 @@ public class SettingNodesValues {
             throw new IllegalArgumentException("Node type " + node.getValueClass().getSimpleName() + " does not equal requested type " + valueClass.getSimpleName() + "!");
         }
 
-        return (T) this.getNodeValue(node);
+        return (T) this.getNodeValueOr((ValueSettingNode<? super T>) node, or);
     }
 
     public <T> void setNodeValue(final @NotNull ValueSettingNode<T> node, final @NotNull T value) {
         this.keyedNodeValues.put(node, value);
         this.nodesByKey.put(node.getKey(), node);
+        this.notifyChanged();
     }
 
     @SuppressWarnings("unchecked")
-    public <T> void setNodeValue(final @NotNull String key, final @NotNull T value, final @NotNull WorldConfiguration worldConfiguration) {
+    public <T> void setNodeValue(final @NotNull String key, final @NotNull T value) {
         @Nullable ValueSettingNode<?> node = this.nodesByKey.get(key);
         if (node == null) {
-            final @Nullable KeyedSettingNode keyedSettingNode = this.rootNode.getChildByKey(key, worldConfiguration);
+            final @Nullable KeyedSettingNode keyedSettingNode = this.rootNode.getChildByKey(key);
             if (keyedSettingNode instanceof final @NotNull ValueSettingNode<?> nodeByKeyFromRoot) {
                 node = nodeByKeyFromRoot;
             } else {
@@ -75,4 +164,10 @@ public class SettingNodesValues {
 
         this.setNodeValue((ValueSettingNode<T>) node, value);
     }
+
+    public void withNotificationsSuppressed(final @NotNull Consumer<@NotNull SettingNodesValues> consumer) {
+        this.notificationsSuppressed = true;
+        consumer.accept(this);
+        this.notificationsSuppressed = false;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/ValueGenericSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/ValueGenericSettingNode.java
index 6ec1dc0a2..11a6ca604 100644
--- a/game/core/src/main/java/net/minecraft/core/world/settings/ValueGenericSettingNode.java
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/ValueGenericSettingNode.java
@@ -1,45 +1,42 @@
 package net.minecraft.core.world.settings;
 
-import net.minecraft.core.lang.text.IntoText;
-import net.minecraft.core.lang.text.LiteralText;
 import net.minecraft.core.lang.text.Text;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.save.WorldConfigurationReader;
 import org.jetbrains.annotations.NotNull;
 
-import java.util.Objects;
-
-public class ValueGenericSettingNode<T> extends GenericSettingNode implements ValueSettingNode<T> {
+public abstract class ValueGenericSettingNode<T> extends GenericSettingNode implements ValueSettingNode<T> {
     private final @NotNull Text name;
-    private final @NotNull T value;
+    private final @NotNull Class<@NotNull T> valueClass;
+
+    private @NotNull ValueSettingNodeVisibilityListener<T> childrenVisibilityListener = ValueSettingNodeVisibilityListener::alwaysVisible;
 
-    public ValueGenericSettingNode(final @NotNull String key, final @NotNull Text name, final @NotNull T defaultValue) {
+    @SuppressWarnings("unchecked")
+    public ValueGenericSettingNode(final @NotNull String key, final @NotNull Text name, final @NotNull Class<T> valueClass) {
         super(key);
 
         this.name = name;
-        this.value = defaultValue;
+        this.valueClass = valueClass;
     }
 
     @Override
-    @SuppressWarnings("unchecked")
     public @NotNull Class<@NotNull T> getValueClass() {
-        return (Class<@NotNull T>) this.value.getClass();
+        return this.valueClass;
     }
 
     @Override
-    public final @NotNull T getDefaultValue() {
-        return this.value;
+    public @NotNull Text getName() {
+        return this.name;
     }
 
-    @Override
-    public @NotNull Text getValueText(final @NotNull T value) {
-        if (value instanceof final @NotNull IntoText intoText) {
-            return intoText.intoText();
-        } else {
-            return new LiteralText(Objects.requireNonNull(value.toString()));
-        }
+    public final @NotNull ValueGenericSettingNode<T> withChildrenVisibilityListener(final @NotNull ValueSettingNodeVisibilityListener<T> childrenVisibilityListener) {
+        this.childrenVisibilityListener = childrenVisibilityListener;
+
+        return this;
     }
 
     @Override
-    public @NotNull Text getName() {
-        return this.name;
+    public boolean areChildrenVisible(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        return this.isVisible(dimension, config) && this.childrenVisibilityListener.isVisible(config, config.getDimensionSettings(dimension).getNodeValue(this, config));
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/ValueSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/ValueSettingNode.java
index ea2c3e7d0..7c29128c4 100644
--- a/game/core/src/main/java/net/minecraft/core/world/settings/ValueSettingNode.java
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/ValueSettingNode.java
@@ -1,12 +1,23 @@
 package net.minecraft.core.world.settings;
 
+import com.mojang.nbt.tags.Tag;
 import net.minecraft.core.lang.text.Text;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.save.WorldConfigurationReader;
 import org.jetbrains.annotations.NotNull;
 
+import java.util.zip.DataFormatException;
+
 public interface ValueSettingNode<T> extends SettingNode, NamedSettingNode, KeyedSettingNode {
     @NotNull Class<@NotNull T> getValueClass();
 
-    @NotNull T getDefaultValue();
+    @NotNull T getDefaultValue(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config);
+
+    boolean validateValue(final @NotNull T value, final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config);
 
     @NotNull Text getValueText(final @NotNull T value);
+
+    @NotNull Tag<?> serializeValue(final @NotNull T value);
+
+    @NotNull T deserializeValue(final @NotNull Tag<?> tag) throws DataFormatException;
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/ValueSettingNodeVisibilityListener.java b/game/core/src/main/java/net/minecraft/core/world/settings/ValueSettingNodeVisibilityListener.java
new file mode 100644
index 000000000..83cf38403
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/ValueSettingNodeVisibilityListener.java
@@ -0,0 +1,18 @@
+package net.minecraft.core.world.settings;
+
+import net.minecraft.core.world.save.WorldConfigurationReader;
+import org.jetbrains.annotations.NotNull;
+
+public interface ValueSettingNodeVisibilityListener<T> {
+    boolean isVisible(final @NotNull WorldConfigurationReader config, final @NotNull T value);
+
+    @SuppressWarnings("unused")
+    static boolean alwaysVisible(final @NotNull WorldConfigurationReader config, final @NotNull Object value) {
+        return true;
+    }
+
+    @SuppressWarnings("unused")
+    static boolean neverVisible(final @NotNull WorldConfigurationReader config, final @NotNull Object value) {
+        return false;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/WorldConfiguration.java b/game/core/src/main/java/net/minecraft/core/world/settings/WorldConfiguration.java
index 9f2cdfb7b..fd116a7a4 100644
--- a/game/core/src/main/java/net/minecraft/core/world/settings/WorldConfiguration.java
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/WorldConfiguration.java
@@ -1,39 +1,86 @@
 package net.minecraft.core.world.settings;
 
+import it.unimi.dsi.fastutil.objects.Object2ObjectArrayMap;
 import net.minecraft.core.data.gamerule.GameRuleCollection;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.config.spawning.SpawnerConfig;
 import net.minecraft.core.world.save.ISaveFormat;
+import net.minecraft.core.world.save.WorldConfigurationReader;
+import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypeGroups;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
+import java.util.Map;
+import java.util.Objects;
 import java.util.Random;
 
-public class WorldConfiguration {
+public class WorldConfiguration implements WorldConfigurationReader {
+    public interface ChangeListener {
+        void onChanged();
+    }
+
     private @NotNull String worldName = "";
     private long numericSeed = new Random().nextLong();
     private @NotNull String stringSeed = "";
     private boolean cheatsEnabled = false;
     private @NotNull Gamemode gamemode = Gamemodes.SURVIVAL;
     private @NotNull WorldTypeGroups.Group worldTypeGroup = WorldTypeGroups.DEFAULT;
-    private @Nullable Biome startingBiome = null;
     private final @NotNull GameRuleCollection gameRuleCollection = new GameRuleCollection();
     private final @NotNull SpawnerConfig spawnerConfig = new SpawnerConfig();
-    private final @NotNull SettingNodesValues settingNodesValues = new SettingNodesValues(DefaultSettingNodes.getRootNode());
+    private final @NotNull Map<@NotNull Dimension, @NotNull SettingNodesValues> worldSettings = new Object2ObjectArrayMap<>();
+    private @Nullable ChangeListener changeListener;
 
     public WorldConfiguration() {
+        for (final @NotNull Dimension dimension : Dimension.getDimensionList().values()) {
+            this.worldSettings.put(dimension, new SettingNodesValues(WorldSettingNodes.getRootNode(), dimension));
+        }
+    }
+
+    public void setChangeListener(final @Nullable ChangeListener changeListener) {
+        this.changeListener = changeListener;
+        this.gameRuleCollection.setChangeListener(this.changeListener);
+        this.spawnerConfig.setChangeListener(this.changeListener);
+        for (final @NotNull SettingNodesValues values : this.worldSettings.values()) {
+            values.setChangeListener(this.changeListener);
+        }
+    }
+
+    private void notifyChanged() {
+        if (this.changeListener != null) {
+            this.changeListener.onChanged();
+        }
+    }
+
+    public @NotNull WorldConfiguration copy() {
+        final @NotNull WorldConfiguration copy = new WorldConfiguration();
+        copy.setWorldName(this.worldName);
+        copy.setNumericSeed(this.numericSeed);
+        copy.setStringSeed(this.stringSeed);
+        copy.setCheatsEnabled(this.cheatsEnabled);
+        copy.setGamemode(this.gamemode);
+        copy.setWorldTypeGroup(this.worldTypeGroup);
+
+        copy.gameRuleCollection.setValues(this.gameRuleCollection);
+        copy.spawnerConfig.set(this.spawnerConfig);
+        for (final @NotNull var key : this.worldSettings.keySet()) {
+            final @NotNull SettingNodesValues values = Objects.requireNonNull(this.worldSettings.get(key));
+            Objects.requireNonNull(copy.worldSettings.get(key)).setAll(values);
+        }
+
+        return copy;
     }
 
     public @NotNull String getWorldName() {
         return this.worldName;
     }
 
+    @Override
     public @NotNull String getFinalWorldName() {
         if (MathHelper.stringNullOrLengthZero(this.worldName)) {
             return I18n.getInstance().translateKey("gui.create_world.label.new_world");
@@ -44,12 +91,14 @@ public class WorldConfiguration {
 
     public void setWorldName(final @NotNull String worldName) {
         this.worldName = worldName;
+        this.notifyChanged();
     }
 
     public long getNumericSeed() {
         return this.numericSeed;
     }
 
+    @Override
     public long getFinalNumericSeed() {
         if (MathHelper.stringNullOrLengthZero(this.stringSeed)) {
             return this.numericSeed;
@@ -69,6 +118,12 @@ public class WorldConfiguration {
 
     public void regenNumericSeed() {
         this.numericSeed = new Random().nextLong();
+        this.notifyChanged();
+    }
+
+    public void setNumericSeed(final long seed) {
+        this.numericSeed = seed;
+        this.notifyChanged();
     }
 
     public @NotNull String getStringSeed() {
@@ -77,14 +132,17 @@ public class WorldConfiguration {
 
     public void setStringSeed(final @NotNull String seed) {
         this.stringSeed = seed;
+        this.notifyChanged();
     }
 
+    @Override
     public boolean getCheatsEnabled() {
         return this.cheatsEnabled;
     }
 
     public void setCheatsEnabled(final boolean cheatsEnabled) {
         this.cheatsEnabled = cheatsEnabled;
+        this.notifyChanged();
     }
 
     public @NotNull Gamemode getGamemode() {
@@ -93,34 +151,36 @@ public class WorldConfiguration {
 
     public void setGamemode(final @NotNull Gamemode gamemode) {
         this.gamemode = gamemode;
+        this.notifyChanged();
     }
 
     public @NotNull WorldTypeGroups.Group getWorldTypeGroup() {
         return this.worldTypeGroup;
     }
 
+    @Override
+    public @NotNull WorldType getWorldType(final @NotNull Dimension dimension) {
+        return this.worldTypeGroup.get(dimension);
+    }
+
     public void setWorldTypeGroup(final @NotNull WorldTypeGroups.Group worldTypeGroup) {
         this.worldTypeGroup = worldTypeGroup;
+        this.notifyChanged();
     }
 
-    public @NotNull GameRuleCollection getGameRuleCollection() {
+    @Override
+    public @NotNull GameRuleCollection getGameRules() {
         return this.gameRuleCollection;
     }
 
+    @Override
     public @NotNull SpawnerConfig getSpawnerConfig() {
         return this.spawnerConfig;
     }
 
-    public void setStartingBiome(@Nullable Biome biome) {
-        this.startingBiome = biome;
-    }
-
-    public @Nullable Biome getStartingBiome() {
-        return this.startingBiome;
-    }
-
-    public @NotNull SettingNodesValues getSettingNodesValues() {
-        return this.settingNodesValues;
+    @Override
+    public @NotNull SettingNodesValues getDimensionSettings(final @NotNull Dimension dimension) {
+        return Objects.requireNonNull(this.worldSettings.get(dimension));
     }
 
     public @NotNull String getFolderName(final @NotNull ISaveFormat saveFormat) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/WorldSettingNodes.java b/game/core/src/main/java/net/minecraft/core/world/settings/WorldSettingNodes.java
new file mode 100644
index 000000000..2573e5d88
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/WorldSettingNodes.java
@@ -0,0 +1,57 @@
+package net.minecraft.core.world.settings;
+
+import net.minecraft.core.lang.text.TranslatableText;
+import net.minecraft.core.world.settings.impl.BiomeSettingNode;
+import net.minecraft.core.world.settings.impl.BooleanSettingNode;
+import net.minecraft.core.world.settings.impl.SeasonSettingNode;
+import net.minecraft.core.world.settings.impl.WorldHeightSettingNode;
+import org.jetbrains.annotations.NotNull;
+
+public final class WorldSettingNodes {
+    private WorldSettingNodes() throws IllegalAccessException {
+        throw new IllegalAccessException("No WorldSettingNodes for you!");
+    }
+
+    public static final @NotNull WorldHeightSettingNode WORLD_HEIGHT_BOTTOM =
+        new WorldHeightSettingNode("minecraft:world_settings/world_height/bottom", new TranslatableText("world_settings.world_height.bottom.name"), WorldHeightSettingNode.DEFAULT_MIN, WorldHeightSettingNode.ValueType.BOTTOM);
+    public static final @NotNull WorldHeightSettingNode WORLD_HEIGHT_TOP =
+        new WorldHeightSettingNode("minecraft:world_settings/world_height/top", new TranslatableText("world_settings.world_height.top.name"), WorldHeightSettingNode.DEFAULT_MAX, WorldHeightSettingNode.ValueType.TOP);
+    public static final @NotNull BooleanSettingNode SINGLE_SEASON_ENABLED = (BooleanSettingNode)
+        new BooleanSettingNode("minecraft:world_settings/single_season/enabled", new TranslatableText("world_settings.single_season.enabled.name"), false)
+            .withChildrenVisibilityListener((config, value) -> value);
+    public static final @NotNull SeasonSettingNode SINGLE_SEASON_VALUE =
+        new SeasonSettingNode("minecraft:world_settings/single_season/value", new TranslatableText("world_settings.single_season.value.name"));
+    public static final @NotNull BooleanSettingNode STARTING_BIOME_ENABLED = (BooleanSettingNode)
+        new BooleanSettingNode("minecraft:world_settings/starting_biome/enabled", new TranslatableText("world_settings.starting_biome.enabled.name"), false)
+            .withChildrenVisibilityListener((config, value) -> value);
+    public static final @NotNull BiomeSettingNode STARTING_BIOME_VALUE =
+        new BiomeSettingNode("minecraft:world_settings/starting_biome/value", new TranslatableText("world_settings.starting_biome.value.name"));
+    public static final @NotNull BooleanSettingNode SINGLE_BIOME_ENABLED = (BooleanSettingNode)
+        new BooleanSettingNode("minecraft:world_settings/single_biome/enabled", new TranslatableText("world_settings.single_biome.enabled.name"), false)
+            .withChildrenVisibilityListener((config, value) -> value);
+    public static final @NotNull BiomeSettingNode SINGLE_BIOME_VALUE =
+        new BiomeSettingNode("minecraft:world_settings/single_biome/value", new TranslatableText("world_settings.single_biome.value.name"));
+
+    private static final @NotNull SettingNode ROOT_NODE;
+    static {
+        ROOT_NODE = new ContainerSettingNode(new ListSettingNodeChildrenProvider())
+            .withChild(WORLD_HEIGHT_BOTTOM)
+            .withChild(WORLD_HEIGHT_TOP)
+            .withChild(
+                SINGLE_SEASON_ENABLED
+                    .withChild(SINGLE_SEASON_VALUE)
+            )
+            .withChild(
+                STARTING_BIOME_ENABLED
+                    .withChild(STARTING_BIOME_VALUE)
+            )
+            .withChild(
+                SINGLE_BIOME_ENABLED
+                    .withChild(SINGLE_BIOME_VALUE)
+            );
+    }
+
+    public static @NotNull SettingNode getRootNode() {
+        return ROOT_NODE;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/impl/BiomeSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/impl/BiomeSettingNode.java
new file mode 100644
index 000000000..3d59d34e6
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/impl/BiomeSettingNode.java
@@ -0,0 +1,62 @@
+package net.minecraft.core.world.settings.impl;
+
+import com.mojang.nbt.tags.StringTag;
+import com.mojang.nbt.tags.Tag;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.lang.text.Text;
+import net.minecraft.core.lang.text.TranslatableText;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.save.WorldConfigurationReader;
+import net.minecraft.core.world.settings.ListValueSettingNode;
+import net.minecraft.core.world.settings.ValueGenericSettingNode;
+import net.minecraft.core.world.type.WorldType;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.List;
+import java.util.Objects;
+import java.util.zip.DataFormatException;
+
+public class BiomeSettingNode extends ValueGenericSettingNode<@NotNull Biome> implements ListValueSettingNode<@NotNull Biome> {
+    public BiomeSettingNode(final @NotNull String key, final @NotNull Text name) {
+        super(key, name, Biome.class);
+    }
+
+    @Override
+    public @NotNull Biome getDefaultValue(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        return this.getValues(dimension, config).get(0);
+    }
+
+    @Override
+    public @NotNull List<@NotNull Biome> getValues(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        final @NotNull WorldType worldType = config.getWorldType(dimension);
+        return Arrays.asList(worldType.allBiomes());
+    }
+
+    @Override
+    public @NotNull Text getValueText(final @NotNull Biome value) {
+        return new TranslatableText(value.translationKey);
+    }
+
+    @Override
+    public @NotNull Tag<?> serializeValue(final @NotNull Biome value) {
+        return new StringTag(Objects.requireNonNull(Registries.BIOMES.getKey(value)));
+    }
+
+    @Override
+    public @NotNull Biome deserializeValue(final @NotNull Tag<?> tag) throws DataFormatException {
+        if (tag instanceof final @NotNull StringTag stringTag) {
+            final @Nullable Biome biome = Registries.BIOMES.getItem(stringTag.getValue());
+            if (biome != null) {
+                return biome;
+            } else {
+                throw new DataFormatException("Illegal biome ID in tag!");
+            }
+        } else {
+            throw new DataFormatException("Tag was wrong type!");
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/impl/BooleanSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/impl/BooleanSettingNode.java
new file mode 100644
index 000000000..05ae5d0d7
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/impl/BooleanSettingNode.java
@@ -0,0 +1,62 @@
+package net.minecraft.core.world.settings.impl;
+
+import com.mojang.nbt.tags.ByteTag;
+import com.mojang.nbt.tags.Tag;
+import net.minecraft.core.lang.text.Text;
+import net.minecraft.core.lang.text.TranslatableText;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.save.WorldConfigurationReader;
+import net.minecraft.core.world.settings.ValueGenericSettingNode;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.zip.DataFormatException;
+
+public class BooleanSettingNode extends ValueGenericSettingNode<@NotNull Boolean> {
+    private static final @NotNull TranslatableText ON = new TranslatableText("world_settings.values.on");
+    private static final @NotNull TranslatableText OFF = new TranslatableText("world_settings.values.off");
+
+    private final boolean defaultValue;
+
+    public BooleanSettingNode(final @NotNull String key, final @NotNull Text name, final boolean defaultValue) {
+        super(key, name, Boolean.class);
+
+        this.defaultValue = defaultValue;
+    }
+
+    @Override
+    public @NotNull Boolean getDefaultValue(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        return this.defaultValue;
+    }
+
+    @Override
+    public boolean validateValue(final @NotNull Boolean value, final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        return true;
+    }
+
+    @Override
+    public @NotNull Text getValueText(final @NotNull Boolean value) {
+        if (value) {
+            return ON;
+        } else {
+            return OFF;
+        }
+    }
+
+    @Override
+    public @NotNull Tag<?> serializeValue(final @NotNull Boolean value) {
+        if (value) {
+            return new ByteTag((byte) 1);
+        } else {
+            return new ByteTag((byte) 0);
+        }
+    }
+
+    @Override
+    public @NotNull Boolean deserializeValue(final @NotNull Tag<?> tag) throws DataFormatException {
+        if (tag instanceof final @NotNull ByteTag byteTag) {
+            return byteTag.getValue() != 0;
+        } else {
+            throw new DataFormatException("Tag was wrong type!");
+        }
+    }
+}
